#include <QtGui>
#include <QtTest/QtTest>

class TestKeyType: public QObject
{
	Q_OBJECT

private slots:
	void testKeyInput_data();
	void testKeyInput();
};

void TestKeyType::testKeyInput_data()
{
	QTest::addColumn<QTestEventList>("events");
	QTest::addColumn<QString>("expected");

	QTestEventList list1;
	list1.addKeyClick('a');
	QTest::newRow("char") << list1 << "a";
	
	QTestEventList list2;
	list2.addKeyClick('a');
	list2.addKeyClick(Qt::Key_Backspace);
	list2.addKeyClick(Qt::Key_Backspace);
	list2.addKeyClick(Qt::Key_Backspace);
	list2.addKeyClick(Qt::Key_Backspace);
	QTest::newRow("there and back again") << list2 << "";

	QTestEventList list3;
	list3.addKeyClick('a');
	list3.addKeyClick('b');
	list3.addKeyClick('c');
	list3.addKeyClick('d');
	QTest::newRow("char") << list3 << "a";
	
}

void TestKeyType::testKeyInput()
{
	QFETCH(QTestEventList, events);
	QFETCH(QString, expected);
	
	QLineEdit lineEdit;
	
	events.simulate(&lineEdit);
	
	QCOMPARE(lineEdit.text(), expected);
}


QTEST_MAIN(TestKeyType)
#include "sample.moc"

