#include "TestPlus.h"
#include <QtTest/QtTest>


class TestCTestPlus: public QObject
{
	Q_OBJECT
private slots:
	void testMinus_data();

	void testPlus();
	void testMixed();
	void testMinus();
};

void TestCTestPlus::testPlus()
{
	CTestPlus sobj;
	QBENCHMARK {
		sobj.value(3);
		sobj.plus(4);
	}
	QCOMPARE(sobj.value(), int(7));
}

void TestCTestPlus::testMixed()
{
	CTestPlus sobj;
	sobj.value(3);
	sobj.plus(4);
	CTestPlus sobj2;
	sobj2.value(10);
	sobj2.minus(3);
	
	QCOMPARE(sobj, sobj2);
}

void TestCTestPlus::testMinus_data()
{
	QTest::addColumn<int>("value");
	QTest::addColumn<int>("minus");
	QTest::addColumn<int>("result");
	
	QTest::newRow("3-4")   << 3   << 4   << -1;
	QTest::newRow("-1+5")  << -1  << -5  << 4;
	QTest::newRow("-1+4")  << -1  << -4  << 5;	//	error
	QTest::newRow("4-3")   << 4   << 3   << 1;
}

void TestCTestPlus::testMinus()
{

	QFETCH(int, value);
	QFETCH(int, minus);
	QFETCH(int, result);

	CTestPlus sobj;
	sobj.value(value);
	
	QCOMPARE(sobj.minus(minus), result);
}

QTEST_MAIN(TestCTestPlus)
#include "sample.moc"
